# -*- coding: UTF-8 -*-

###########################################################################
# Eole NG - 2007
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr
#
# gest_sessions.py
#
# Librairie pour la gestion des clients Windows
#
###########################################################################
 

import sys, os, time

sys.path.append('/usr/share/eole/backend')
sys.path.append('/usr/share/eole/controlevnc')

import connectes
import ldap_utils
from cliscribe import Cliscribe

class Logon:
    def __init__(self):
        """Gestion d'ouverture de session sur les postes clients (windows 2K/XP pour l'instant)
        - gestion VNC
        """

    def logon(self, ip, os_type, bloc):
        self.ip, self.os_type, self.bloc = ip, os_type, bloc
        self.user = connectes.get_user(self.ip)
        self.groups = ldap_utils.get_user_groups(self.user)
        self.sid = ldap_utils.get_user_sid(self.user)
        self.vnc()
        self.blocage()
        return True

    def blocage(self):
        if 'eleves' in self.groups:
            self.bloc.bloc_user(self.user, self.ip, logon=True)
        else:
            # on débloque si pas prof
            self.bloc.init_net(self.ip)

    def get_vnc_mode(self):
        """récupère le type de controle défini dans l'EAD
        simple, controle, désactivé
        """
        if os.path.isfile('/var/www/ead/config/controle'):
            typecontrole = file('/var/www/ead/config/controle').readlines()[0].strip()
        else: typecontrole = 'simple'
        return typecontrole

    def vnc(self):
        """active le type de controle sur la station (lu par controle-vnc / gestion-postes.exe)
        et arrête le service winvnc si user n'est pas élève
        """
        if 'eleves' not in self.groups:
            Cliscribe(self.ip).vnc(action='stop')
        mode = self.get_vnc_mode()
        reg_dict = { 'hkey' : 'HKEY_LOCAL_MACHINE',
                'keypath' : 'Software\\Eole\\Scribe', 'keyname' : 'vnc_viewonly', 'keytype' : 'REG_SZ', 'value' : mode}
        Cliscribe(self.ip).winreg(reg_dict=reg_dict)

